package betterwithmods.module.hardcore.needs;

import betterwithmods.module.Feature;
import betterwithmods.module.ModuleLoader;
import betterwithmods.util.item.StackMap;
import betterwithmods.util.player.PlayerHelper;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.attributes.AttributeModifier;
import net.minecraft.entity.monster.AbstractSkeleton;
import net.minecraft.entity.monster.EntityZombie;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemStack;
import net.minecraftforge.event.entity.living.LivingEvent;
import net.minecraftforge.event.entity.living.LivingSpawnEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.oredict.OreDictionary;

import java.util.Calendar;

/**
 * Created by tyler on 5/10/17.
 */
public class HCArmor extends Feature {
    public static final StackMap<Integer> weights = new StackMap<>(0);

    public static final EntityEquipmentSlot[] ARMOR_SLOTS = new EntityEquipmentSlot[]{EntityEquipmentSlot.HEAD, EntityEquipmentSlot.CHEST, EntityEquipmentSlot.LEGS, EntityEquipmentSlot.FEET};
    public static final ItemStack[] IRON_ARMOR = new ItemStack[]{new ItemStack(Items.field_151028_Y), new ItemStack(Items.field_151030_Z), new ItemStack(Items.field_151165_aa), new ItemStack(Items.field_151167_ab)};

    public static boolean changeArmorSpawns;

    public static float getWeight(ItemStack stack) {
        if (!ModuleLoader.isFeatureEnabled(HCArmor.class))
            return 0;
        return weights.get(stack);
    }

    public static void initWeights() {
        weights.put(Items.field_151020_U, OreDictionary.WILDCARD_VALUE, 3);
        weights.put(Items.field_151023_V, OreDictionary.WILDCARD_VALUE, 4);
        weights.put(Items.field_151022_W, OreDictionary.WILDCARD_VALUE, 4);
        weights.put(Items.field_151029_X, OreDictionary.WILDCARD_VALUE, 2);

        weights.put(Items.field_151028_Y, OreDictionary.WILDCARD_VALUE, 5);
        weights.put(Items.field_151030_Z, OreDictionary.WILDCARD_VALUE, 8);
        weights.put(Items.field_151165_aa, OreDictionary.WILDCARD_VALUE, 7);
        weights.put(Items.field_151167_ab, OreDictionary.WILDCARD_VALUE, 4);

        weights.put(Items.field_151161_ac, OreDictionary.WILDCARD_VALUE, 5);
        weights.put(Items.field_151163_ad, OreDictionary.WILDCARD_VALUE, 8);
        weights.put(Items.field_151173_ae, OreDictionary.WILDCARD_VALUE, 7);
        weights.put(Items.field_151175_af, OreDictionary.WILDCARD_VALUE, 4);

        weights.put(Items.field_151169_ag, OreDictionary.WILDCARD_VALUE, 5);
        weights.put(Items.field_151171_ah, OreDictionary.WILDCARD_VALUE, 8);
        weights.put(Items.field_151149_ai, OreDictionary.WILDCARD_VALUE, 7);
        weights.put(Items.field_151151_aj, OreDictionary.WILDCARD_VALUE, 4);
    }

    public static void setSkeletonEquipment(AbstractSkeleton entity) {
        entity.func_85036_m();
        entity.func_98053_h(entity.func_70681_au().nextFloat() <= 0.25);
        entity.func_184201_a(EntityEquipmentSlot.MAINHAND, new ItemStack(Items.field_151031_f));
        halloween(entity);
    }

    public static void setZombieEquipment(EntityZombie entity) {
        entity.func_98053_h(entity.func_70681_au().nextFloat() <= 0.25);
        entity.func_146070_a(true);

        //tool
        if (entity.func_70681_au().nextFloat() < 0.05F) {
            int i = entity.func_70681_au().nextInt(3);
            if (i == 0) {
                entity.func_184201_a(EntityEquipmentSlot.MAINHAND, new ItemStack(Items.field_151040_l));
            } else {
                entity.func_184201_a(EntityEquipmentSlot.MAINHAND, new ItemStack(Items.field_151037_a));
            }
        }

        //armor
        if (entity.func_70681_au().nextFloat() < 0.018) {
            boolean flag = true;
            for (int s = 0; s < ARMOR_SLOTS.length; s++) {
                EntityEquipmentSlot slot = ARMOR_SLOTS[s];
                ItemStack current = entity.func_184582_a(slot);
                if (current.func_190926_b()) {
                    if (!flag && entity.func_70681_au().nextFloat() < 0.1) {
                        break;
                    }
                    flag = false;
                    entity.func_184201_a(slot, IRON_ARMOR[s]);
                }
            }
        }
        halloween(entity);
        entity.func_110148_a(SharedMonsterAttributes.field_111266_c).func_111121_a(new AttributeModifier("Random spawn bonus", entity.func_70681_au().nextDouble() * 0.05000000074505806D, 0));
        double d0 = entity.func_70681_au().nextDouble() * 1.5D * 0.012;
        if (d0 > 1.0D) {
            entity.func_110148_a(SharedMonsterAttributes.field_111265_b).func_111121_a(new AttributeModifier("Random zombie-spawn bonus", d0, 2));
        }
    }

    @Override
    public void init(FMLInitializationEvent event) {
        initWeights();
    }

    @SubscribeEvent
    public void swimmingPenalty(LivingEvent.LivingUpdateEvent event) {
        if (!(event.getEntityLiving() instanceof EntityPlayer))
            return;
        EntityPlayer player = (EntityPlayer) event.getEntityLiving();
        if (PlayerHelper.isSurvival(player) && player.func_70090_H() && !PlayerHelper.canSwim(player) && !PlayerHelper.isNearBottom(player)) {
            player.field_70181_x -= 0.02;
        }
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }

    public static void halloween(EntityLiving entity) {
        if (entity.func_184582_a(EntityEquipmentSlot.HEAD).func_190926_b()) {
            Calendar calendar = entity.field_70170_p.func_83015_S();
            if (calendar.get(Calendar.MONTH) + 1 == 10 && calendar.get(Calendar.DATE) == 31 && entity.func_70681_au().nextFloat() < 0.25F) {
                entity.func_184201_a(EntityEquipmentSlot.HEAD, new ItemStack(entity.func_70681_au().nextFloat() < 0.1F ? Blocks.field_150428_aP : Blocks.field_150423_aK));
                entity.func_184642_a(EntityEquipmentSlot.HEAD, 0.0F);
            }
        }
    }

    @Override
    public void setupConfig() {
        changeArmorSpawns = loadPropBool("Change Armor Spawns", "Changes Entity armor spawning: Zombies only spawn with Iron armor, Skeletons never wear armor.", true);
    }

    @Override
    public String getFeatureDescription() {
        return "Gives Armor weight values that effect movement. Changes Entity armor spawning: Zombies only spawn with Iron armor, Skeletons never wear armor.";
    }

    @SubscribeEvent
    public void onSpecialSpawn(LivingSpawnEvent.SpecialSpawn event) {
        if (!changeArmorSpawns)
            return;
        if (event.getEntityLiving() instanceof EntityZombie) {
            event.setCanceled(true);
            EntityZombie entity = (EntityZombie) event.getEntityLiving();
            setZombieEquipment(entity);
        }
        if (event.getEntityLiving() instanceof AbstractSkeleton) {
            event.setCanceled(true);
            setSkeletonEquipment((AbstractSkeleton) event.getEntityLiving());
        }
    }
}
